﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ContainerShip
{
    internal class DrawingContainerShip : DrawingShip
    {
        /// <summary>
        /// Инициализация свойств
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес автомобиля</param>
        /// <param name="bodyColor">Цвет кузова</param>
        /// <param name="dopColor">Дополнительный цвет</param>
        /// <param name="bodyKit">Признак наличия обвеса</param>
        /// <param name="wing">Признак наличия антикрыла</param>
        /// <param name="sportLine">Признак наличия гоночной полосы</param>
        public DrawingContainerShip(int speed, float weight, Color bodyColor, Color dopColor, bool crane, bool containers) :
            base(speed, weight, bodyColor, 135, 70)
        {
            Ship = new EntityContainerShip(speed, weight, bodyColor, dopColor, crane, containers);
        }
        public override void DrawTransport(Graphics g)
        {
            if (Ship is not EntityContainerShip containerShip)
            {
                return;
            }

            Pen pen = new(Color.Black);
            Brush dopBrush = new SolidBrush(containerShip.DopColor);
            Pen dopPen = new (containerShip.DopColor);

            _startPosY += 30;
            base.DrawTransport(g);
            _startPosY -= 30;
            int _startPosYInt = (int)_startPosY;
            int _startPosXInt = (int)_startPosX;
            if (containerShip.Containers)
            {
                Point[] container1 =
                {
                    new Point(_startPosXInt + 5, _startPosYInt + 45),
                    new Point(_startPosXInt + 5, _startPosYInt + 35),
                    new Point(_startPosXInt + 25, _startPosYInt + 35),
                    new Point(_startPosXInt + 25, _startPosYInt + 45)
                };


                Point[] container2 =
                {
                    new Point(_startPosXInt + 40, _startPosYInt + 45),
                    new Point(_startPosXInt + 40, _startPosYInt + 35),
                    new Point(_startPosXInt + 75, _startPosYInt + 35),
                    new Point(_startPosXInt + 75, _startPosYInt + 45),
                    
                };

                Point[] container3 =
                {
                    new Point(_startPosXInt + 80, _startPosYInt + 45),
                    new Point(_startPosXInt + 80, _startPosYInt + 35),
                    new Point(_startPosXInt + 110, _startPosYInt + 35),
                    new Point(_startPosXInt + 110, _startPosYInt + 45)
                };

                Point[] container4 =
                {
                    new Point(_startPosXInt + 110, _startPosYInt + 30),
                    new Point(_startPosXInt + 110, _startPosYInt + 45),
                    new Point(_startPosXInt + 130, _startPosYInt + 45),
                    new Point(_startPosXInt + 130, _startPosYInt + 30)
                };

                g.FillPolygon(dopBrush, container1);
                g.DrawPolygon(pen, container1);
                g.FillPolygon(dopBrush, container2);
                g.DrawPolygon(pen, container2);
                g.FillPolygon(dopBrush, container3);
                g.DrawPolygon(pen, container3);
                g.FillPolygon(dopBrush, container4);
                g.DrawPolygon(pen, container4);


            }
            if (containerShip.Crane)
            {
                g.DrawLine(dopPen, _startPosX + 40, _startPosY + 15, _startPosX + 40, _startPosY);
                g.DrawLine(dopPen, _startPosX + 40, _startPosY, _startPosX + 80, _startPosY);
                g.DrawLine(dopPen, _startPosX + 40, _startPosY, _startPosX + 80, _startPosY + 5);
                g.DrawLine(dopPen, _startPosX + 80, _startPosY, _startPosX + 80, _startPosY + 30);
            }

        }
    }
}

