﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ContainerShip
{
    public partial class FormShipConfig : Form
    {
        DrawingShip _ship = null;
        private event Action<DrawingShip> EventAddShip;      
        public FormShipConfig()
        {
            InitializeComponent();
            panelBlack.MouseDown += PanelColor_MouseDown;
            panelPurple.MouseDown += PanelColor_MouseDown;
            panelGray.MouseDown += PanelColor_MouseDown;
            panelGreen.MouseDown += PanelColor_MouseDown;
            panelRed.MouseDown += PanelColor_MouseDown;
            panelWhite.MouseDown += PanelColor_MouseDown;
            panelYellow.MouseDown += PanelColor_MouseDown;
            panelBlue.MouseDown += PanelColor_MouseDown;
            buttonCancel.Click += (object sender, EventArgs e) => Close();
        }
        private void DrawShip()
        {
            Bitmap bmp = new(pictureBoxObject.Width, pictureBoxObject.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _ship?.SetPosition(5, 5, pictureBoxObject.Width, pictureBoxObject.Height);
            _ship?.DrawTransport(gr);
            pictureBoxObject.Image = bmp;
        }
        private void LabelObject_MouseDown(object sender, MouseEventArgs e)
        {
            (sender as Label).DoDragDrop((sender as Label).Name, DragDropEffects.Move | DragDropEffects.Copy);
        }
        private void PanelObject_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.Text))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }
        public void AddEvent(Action<DrawingShip> ev)
        {
            if (EventAddShip == null)
            {
                EventAddShip = ev;
            }
            else
            {
                EventAddShip += ev;
            }
        }
        private void PanelObject_DragDrop(object sender, DragEventArgs e)
        {
            switch (e.Data.GetData(DataFormats.Text).ToString())
            {
                case "labelSimpleObject":
                    _ship = new DrawingShip((int)numericUpDownSpeed.Value, (int)numericUpDownWeight.Value, Color.White);
                    break;
                case "labelModifiedObject":
                   _ship = new DrawingContainerShip((int)numericUpDownSpeed.Value, (int)numericUpDownWeight.Value, Color.White, Color.Black,
                        checkBoxCrane.Checked, checkBoxContainers.Checked);
                    break;
            }
            DrawShip();
        }
        private void PanelColor_MouseDown(object sender, MouseEventArgs e)
        {
            (sender as Control).DoDragDrop((sender as Control).BackColor.Name, DragDropEffects.Move | DragDropEffects.Copy);
        }
        private void LabelColor_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(typeof(String)))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }
        private void LabelBaseColor_DragDrop(object sender, DragEventArgs e)
        {
            _ship?.Ship?.setColor(Color.FromName(e.Data.GetData(DataFormats.Text).ToString()));
            DrawShip();
        }
        private void LabelDopColor_DragDrop(object sender, DragEventArgs e)
        {
            if (_ship.Ship is EntityContainerShip ContainerShip)
            {
                ContainerShip.setDopColor(Color.FromName(e.Data.GetData(DataFormats.Text).ToString()));
                DrawShip();
            }
        }
        private void ButtonOk_Click(object sender, EventArgs e)
        {
            EventAddShip?.Invoke(_ship);
            Close();
        }
    }
}
